<?php

/**
 * inf_ven_consol_cliente actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_consol_ven_men_detaActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            /* if (isset($request['estado'])) {
              if ($request['estado'] == 'false') {
              $estado = 0;
              } else {
              $estado = 1;
              }
              } else {
              $estado = 1;
              } */

            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_grupo'])) {
                $whereGrupo = " AND tab0.id_grupo = " . $request['id_grupo'];
            } else {
                $whereGrupo = ' ';
            }

            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (

Select 

2 as orden,
id_punto_venta as id_punto_venta,
null as pv,
'TOTAL '|| grupo as grupo,
id_grupo as id_grupo,
null as id_producto,
null as producto,            
sum(cantidad) as cantidad,
sum(subtotal) as subtotal,           
sum(recaudado) as recaudado,
sum(cartera) as cartera
            
from(
 
SELECT 

tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA
    from(
            
select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto,tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1
     
    )tab0
where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto
    
            
)
group by id_punto_venta,pv,id_grupo,grupo
       
            
UNION
            
Select 

3 as orden,
id_punto_venta as id_punto_venta,
'TOTAL '|| pv as pv,
null as grupo,
null as id_grupo,
null as id_producto,
null as producto,            
sum(cantidad) as cantidad,
sum(subtotal) as subtotal,           
sum(recaudado) as recaudado,
sum(cartera) as cartera
            
from(
 
SELECT 

tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA
    from(
            
select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto,tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1
     
    )tab0
where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto
    
            
)
group by id_punto_venta,pv            
       
UNION            
            
Select 
            
1 as orden,
tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA        
 
from(

select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto, tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1

)tab0

where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto

order by id_punto_venta,id_grupo,orden

)
)

EOD;




            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];





            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

Select 

2 as orden,
id_punto_venta as id_punto_venta,
null as pv,
'TOTAL '|| grupo as grupo,
id_grupo as id_grupo,
null as id_producto,
null as producto,            
sum(cantidad) as cantidad,
sum(subtotal) as subtotal,           
sum(recaudado) as recaudado,
sum(cartera) as cartera
            
from(
 
SELECT 

tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA
    from(
            
select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto,tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1
     
    )tab0
where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto
    
            
)
group by id_punto_venta,pv,id_grupo,grupo
       
            
UNION
            
Select 

3 as orden,
id_punto_venta as id_punto_venta,
'TOTAL '|| pv as pv,
null as grupo,
null as id_grupo,
null as id_producto,
null as producto,            
sum(cantidad) as cantidad,
sum(subtotal) as subtotal,           
sum(recaudado) as recaudado,
sum(cartera) as cartera
            
from(
 
SELECT 

tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA
    from(
            
select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto,tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1
     
    )tab0
where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto
    
            
)
group by id_punto_venta,pv            
       
UNION            
            
Select 
            
1 as orden,
tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
tab0.id_producto AS ID_PRODUCTO,
tab0.producto AS PRODUCTO,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA        
 
from(

select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab2.id_producto, tab2.descripcion AS PRODUCTO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab7.id_producto, tab7.descripcion AS PRODUCTO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1

)tab0

where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo,tab0.id_producto,tab0.producto

order by id_punto_venta,id_grupo,orden
        
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart

EOD;
            



            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe inf_ven_consol_cliente
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            
            /*
             * Variables opcionales
             */
            //tercero
            if (isset($request['id_mae_ter'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }

            //PUNTO DE VENTA

            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
            } else {
                $wherePuntoVenta = ' ';
            }


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT 
    
count(*) as pv, 
'TOTALES' as descripcion,

SUM(NVL(cantidad,0)) as cantidad, 
SUM(NVL(subtotal,0)) as subtotal, 
SUM(NVL(recaudado,0)) as recaudado,
SUM(NVL(cartera,0)) as cartera

FROM (

SELECT 

tab0.id_punto_venta as id_punto_venta,
tab0.descripcion as pv,
tab0.grupo as grupo,
tab0.id_grupo as id_grupo,
sum(tab0.cantidad) AS CANTIDAD,
sum(NVL(SUBTOTAL,0)) AS SUBTOTAL,
sum(NVL(tab0.RECAUDADO,0)) AS RECAUDADO,
sum(NVL(tab0.CARTERA,0)) AS CARTERA
    from(
            
select rownum, tab4.id_punto_venta,tab5.descripcion,tab3.id AS ID_GRUPO,tab3.descripcion AS GRUPO,tab1.cantidad,tab1.valor_uni_total AS SUBTOTAL,tab1.valor_uni_total AS RECAUDADO, 0 AS CARTERA

from ca_factura_prod tab1


left join ca_producto tab2 ON tab2.id_producto = tab1.id_producto
left join ts_gi tab3 ON tab3.id = tab2.id_grupo
left join ca_factura_pos tab4 ON tab4.id_factura = tab1.id_factura
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta

where To_Char(tab4.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


union

select rownum, tab9.id_punto_venta,tab10.descripcion,tab8.id AS ID_GRUPO,tab8.descripcion AS GRUPO,tab6.cantidad,tab6.valor_total AS SUBTOTAL, 0 AS RECAUDADO, tab6.valor_totaL AS CARTERA

from ca_debito_detalle tab6

left join ca_producto tab7 ON tab7.id_producto = tab6.id_producto
left join ts_gi tab8 ON tab8.id = tab7.id_grupo
left join ca_debito tab9 ON tab9.id_debito = tab6.id_debito
left join ca_punto_venta tab10 ON tab10.id_punto_venta = tab9.id_punto_venta

where tab9.id_tipo_debito=1 and To_Char(tab9.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab9.estado=1
     
    )tab0
where tab0.id_punto_venta IS NOT NULL $wherePuntoVenta
    
GROUP BY tab0.id_punto_venta,tab0.descripcion,tab0.id_grupo,tab0.grupo

)
EOD;

        
                   

            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
